 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: Assistant.h,v 1.3 2001/03/18 22:21:25 daville Exp $
 * $Log: Assistant.h,v $
 * Revision 1.3  2001/03/18 22:21:25  daville
 * Ajout de lignes fin fichier.
 *
 * Revision 1.2  2000/11/02 21:40:25  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef ASSISTANT_H
#define ASSISTANT_H
#include "XMProtocol.h"

////////////////////////////////////////////////////////////
SCConnection * ConnectClient();
void   *SendToAssistant(int id_client, char *com);
int    DisconnectClient(int id_client, void  (*DeleteFlux)(XMPipe *&pipe, int id_user));
int    DisconnectAllClient(void (*DeleteFlux)(XMPipe *&pipe, int id_user));
XMPipe *GetPipeConnection(int k);
XMPipe *GetPipeClient(int id);
int AddIntoMemory(int id_client, void *objx);
void *GetObjectX(int id_client, char *name);
////////////////////////////////////////////////////////////

#endif   /* ASSISTANT_H */


