 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: FichierConf.cpp,v 1.3 2001/03/18 22:34:35 daville Exp $
 * $Log: FichierConf.cpp,v $
 * Revision 1.3  2001/03/18 22:34:35  daville
 * Ajout de lignes fin fichier.
 *
 * Revision 1.2  2000/11/02 21:47:38  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include <FichierConf.h>

#define TAILLE_LIGNE		2000
#define DEBUT_COMMENTAIRE	'#'


FILE *OuvrirFichierConf(char *nom_fichier)
{
	return fopen(nom_fichier, "r");
}

char *LireParametreFichierConf(FILE *fichier, char *nom_section, char *nom_parametre)
{
	if (!fichier) return NULL;
	int EtatSection=-1;
	char *Result = NULL;
	char Buffer[TAILLE_LIGNE];
	char Section[strlen(nom_section)+3];
	char NomParametre[50], ValeurParametre[500], *Ptr;
	
	sprintf(Section, "[%s]", nom_section);
	while ((fscanf(fichier, "%s", &Buffer)) && (EtatSection <1))
	{
		if (Buffer[0] == DEBUT_COMMENTAIRE) continue;
		if (strstr(Buffer, Section)) {EtatSection=0; continue;}
		if (strstr(Buffer, "[")) {EtatSection=1; continue;}
		if (EtatSection == -1) continue;
		
		Ptr = strstr(Buffer, "=");
		strncpy(NomParametre, Buffer, Ptr - Buffer); NomParametre[Ptr - Buffer]='\0';
		if (!strcmp(NomParametre, nom_parametre))
		{
			Result = new char[strlen(Buffer)-strlen(NomParametre)+1];
			strncpy(Result, Ptr+1, strlen(Buffer)-strlen(NomParametre));Result[strlen(Buffer)-strlen(NomParametre)+1]='\0';
			break;
		}
	}
	return Result;
}

int EcrireParametreFichierConf(FILE *fichier, char *nom_section, char *nom_parametre, char *valeur_parametre)
{
	return 0;
}

int FermerFichierConf(FILE *fichier)
{
	fclose(fichier);
	return 0;
}

