 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: maths.cpp,v 1.3 2001/04/04 20:57:27 daville Exp $
 * $Log: maths.cpp,v $
 * Revision 1.3  2001/04/04 20:57:27  daville
 * Ajout de l'oprateur return pour le fonctions qui retournent des valeurs.
 *
 * Revision 1.2  2000/11/02 22:10:08  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#include <stdio.h>
#include "chaine.h"
#include "number.h"
#include "Liste.h"
#include "maths.h"

int DecompFonction(char *Expression, char **NomFonc, char **Variabl, char **MessageErr)
{
    /*    char *Tmp,*Buf1,*Buf2;
        int i,N=0;
        
        printf("\n L'expression: %s",Expression);
        getchar();
        Variabl[0]=NomFonc[0]=NULL;
        Tmp= strchr(Expression,'=');
        printf("\nPour la recherche %s",Tmp);
        getchar();
        if (Tmp)
        {
                N= (int )(Tmp-Expression);
                printf("\n%d",N);
                getchar();
                Tmp= new char[N+1];
                printf("\n Apres allocation");
                getchar();
                for(i=0;i<N;i++) Tmp[i]=Expression[i];
                Tmp[i]='\0';
                printf("\n Ecriture dans Tmp %s",Tmp);
                getchar();
                Buf1= strchr(Tmp,'(');
                printf("\n La position de la parenthese ( %d",Buf1-Tmp);
                getchar();
                Buf2= strchr(Tmp,')');
                if (((Buf1) && (Buf2)) && (Buf2==Buf1++))
                {
                        MessageErr[0]=new char[strlen("Zonede variable vide")];
                        strcpy(MessageErr[0],"Zone de variable vide");
                        return 1;
                }
                if (((Buf1) && (!Buf2)) || ((!Buf1) && (Buf2)))
                {
           /***  A revoir  ****/
           		
          /* 		MessageErr[0]=new char [strlen(") requise dans ")+strlen(Tmp)];
                        if (Buf1)
                        {
                                strcpy(MessageErr[0],") requise dans ");
                                for(i=0;Tmp[i];i++) MessageErr[0][i+15]=Tmp[i];
                        } else
                        {
                                strcpy(MessageErr[0],"( requise dans ");
                                for(i=0;Tmp[i];i++) MessageErr[0][i+15]=Tmp[i];
                        }
                        return 1;
                }
                if (!Buf1) *NomFonc = Copie(0,strlen(Tmp),Tmp); else
                {
                        NomFonc[0]=new char[(int)(Buf1-Tmp)];
                        printf("\n On a %d",Buf1-Tmp-1);
                        for(i=0;i<(int)(Buf1-Tmp)-1;i++) NomFonc[0][i]=Tmp[i];
                        NomFonc[0][i]='\0';
                        Tmp[i-2]='\0';
                        printf("\n Nom de la fonction: %s",NomFonc[0]);
                        getchar();
                        for(i=0;Tmp[(int)(Buf1-Tmp)+i];i++) Tmp[i]=Tmp[(int)(Buf1-Tmp)+i];
                        Tmp[i-1]='\0';i=0;
                        printf("\n Il nous reste: %s",Tmp);
                        getchar();
                        while (Tmp[i])
                        {
                                if ((!EstDansAZaz(Tmp[i])) && (Tmp[i]!=',') && (!((Tmp[i]>=48) && (Tmp[i]<=57))))
                                {
                                        MessageErr[0]=new char[1+strlen(" est impropre dans ")+strlen(Tmp)];
                                        MessageErr[0][0]=Tmp[i];
                                        char *Tab=" est impropre dans ";
                                        for (i=0;Tab[i];i++) MessageErr[0][1+i]=Tab[i];
                                        N=i; for (i=0;Tmp[i];i++) MessageErr[0][N+i]=Tmp[i];
                                        return 1;
                                } i++;
                        }
                        Variabl[0]=new char[strlen(Tmp)+1];
                        strcpy(Variabl[0],Tmp);
                        printf("\n en dernier la variable: %s",Variabl[0]);
                        getchar();N++;
                        for (i=0;Expression[N+i];i++) Expression[i]=Expression[N+i];
                        Expression[i]='\0';
                        printf("\n Expression de la fonction: %s",Expression);
                        getchar();
                        return 0;
                        delete Tmp;
                }                          
        }*/
        return 0;
}


int DecompIntervalle(char *Intervalle, char **VarI, TYPE &x1, TYPE &x2, char **MessageErr)
{
        /*int j, i, PosEgal;
        char *X1S, *X2S, *Tmp, *Interval;
        TYPE u1,u2;
        
        
        Tmp=strchr(Intervalle,',');
        printf("\n %p et %s",Tmp,Tmp);
        getchar();
        if (Tmp)
        {
                PosEgal=(int)(Tmp-Intervalle);
                printf("\n %d",PosEgal);
                getchar();
                Interval=new char [PosEgal+1];
                for (i=0;i<PosEgal;i++) Interval[i]= Intervalle[i]; Interval[i]='\0';
                for(i=0;i<PosEgal;i++) Intervalle[i]=Intervalle[PosEgal+i]; Intervalle[i]='\0';
        	/*ss[i+PosEgal-1]='\0';*/
        	
        /*	printf("\n Premier intervalle %s",Interval);
        	getchar();
        } else
        {
                Interval=new char [strlen(Intervalle)+1];
                strcpy(Interval,Intervalle);
                printf("\n Et voici l'intervalle %s",Interval);
                getchar();
        }
        Tmp=strchr(Interval,'=');
        printf("\n %p et la position %d",Tmp,Tmp-Interval);
        getchar();
       	if (Tmp)
       	{
       	        printf("\n nous avons %d",Tmp);
       	        getchar();
if (  (!EstDansAZaz(Interval[(int)(Tmp-Interval)-1])) && ((!Interval[(int)(Tmp-Interval)-1]>=49) || (!Interval[(int)(Tmp-Interval)]<=57)))
       	        {
       	                i=strlen("Mauvaise dfinition de l'intervalle ");
       	                MessageErr[0]=new char[i+strlen(Interval)+1];
       	                strcpy(MessageErr[0],"Mauvaise dfinition de l'intervalle ");
       	                for(j=0;Interval[j];j++) MessageErr[0][j+i]=Interval[i];
			MessageErr[0][i]='\0';
       	         	return 1;
       	         }
       	         j=Tmp-Interval;
       	         printf("\n Voici l'intervalle %s",Interval);
       	         VarI[0]=new char[j+1];
       	         for (i=0;i<j;i++) VarI[0][i]=Interval[i];
       	         VarI[0][i]='\0';
       	         printf("\n la variable est :%s",VarI[0]);
       	         getchar();
       	         for (i=0;Interval[i+j+1];i++) Interval[i]=Interval[j+i+1];
       	         Interval[i]='\0';
       	         printf("\n Reste de l'intervalle %s",Interval);
       	         getchar();
       	         Tmp=strchr(Interval,'.');
       	         if ((!Tmp) || (Interval[(int)(Tmp-Interval)+1]!='.'))
       	         {
       	                MessageErr[0]=new char[strlen(".. ncessaire dans l'intervalle")];
       	                strcpy(MessageErr[0],".. ncessaire dans l'intervalle.");
       	                return 1;
       	         }
       	         X1S=new char[(int)(Tmp-Interval)];
       	         for (i=0;Interval[i]!='.';i++) X1S[i]= Interval[i];
       	         X1S[i]='\0';i++;
       	         printf("%s",X1S);
       	         getchar();
       	         for (j=0;Interval[j+i+1];j++) Interval[j]=Interval[i+j+1]; Interval[j]='\0';
       	         X2S=new char[strlen(Interval)+1];
       	         strcpy(X2S,Interval);
       	         printf("%s",X2S);
       	         getchar();
       	         val(X1S,u1,i); val(X2S,u2,j);
       	         if ((!i) && (!j) && (u1>=u2))
       	         {
       	                if (u1=u2)
       	                {
       	                        MessageErr[0]=new  char[strlen("Intervalle vide.")];
       	                        strcpy(MessageErr[0],"Intervalle vide.");
       	                        return 1;
       	                 }
       	                 i=strlen(X1S); j=strlen(X2S);
       	                 MessageErr[0]= new char[i+strlen(" doit tre infrieur  ")+j];
       	                 
       	         }
       	   /*  Sinon on ira rechercher la valeur de X1S ou X2S   */
       	
       	/*         x1=u1; x2=u2;
       	} else
       	{
       	        i=strlen(Interval);
       	        j=strlen(" n'est pas un intervalle.");
       	        MessageErr[0]=new char[i+j+1];
       	        strcpy(MessageErr[0],strcat(Interval, " n'est pas un intervalle."));
       	        return 1;
       	}
       	delete Interval;
       	delete X2S; delete X1S;*/
       	return 0;
}

XMFonction *DoFonction(char *Nom, char *Exp, char *Intervalles, int &Ex)
{
/*        printf("\n L'expression  traiter est %s",Exp);
        TYPE x1, x2;
        int i=0;
        XMVariable Va;
        CList <XMVariable> L;
        printf("\nLe nom %s et l'expression %s",Nom,Exp);
        getchar();
        XMFonction *F=new XMFonction(Nom,Exp);
        char *Inter,*NomVar[1];
        char *Intervals=new char [strlen(Intervalles)+1];
        
        strcpy(Intervals,Intervalles);
        while (Inter=GetIntervalle(Intervals,','))
        {
                DecompIntervalle(Inter,NomVar,x1,x2,NULL);
                Va.Nom=new char[strlen(NomVar[0])+1];
                strcpy(Va.Nom,NomVar[0]);
                Va.Dep=Va.X=x1;
                Va.Fin=x2;
                printf("\n Mise en place de la variable %s",Va.Nom);
                getchar();
                L.Add(Va);
                delete Inter;
        }
        L.MoveFirst(Va);
        F->SetVar(L.GetCount());
        while (!L.Eol())
        {
  //              F->PutVar(Va,i);i++;
                L.MoveNext(Va);
        }
        delete Intervals;
        Ex=1;*/ return 0;
}

XMFonction *DoFonction(char *Exp, char **Message)
{
/*        char *PosEgal=strchr(Exp,'=');
        if (!PosEgal) return NULL;
        int i,n=(int)(PosEgal-Exp);
        char *Tmp=Copie(1,n-1,Exp);
        char *Nom[1];
        if (!TestFonction(Tmp,Nom))
        {
                delete Tmp;
                return NULL;
        }
        i=strlen(Exp);
        char *Expression=Copie(n+2,i,Exp);
        XMFonction *F=new XMFonction(Nom[0],Expression);
        F->Init();
        F->Arbrer();
        getchar();
        delete Tmp; delete PosEgal;
        delete Expression; delete Nom[0];
        return F;*/
        return 0;
}

char *GetIntervalle(char *Exp, char c)// dans 'x, y, z' on a: renvoye
{				      // 'x' et Exp='y ,z'
        char *Tmp=strchr(Exp,c);
        char *Res; int n,i;
        if (Tmp)
        {
                n=(int)(Tmp-Exp);
                Res=new char[n+1];
        	for(i=0;i<n;i++) Res[i]=Exp[i]; Res[i]='\0';
        	for(i=0;Exp[n+i];i++) Exp[i]=Exp[i+n]; Exp[i]='\0';
        	return Res;
        	
        }else
        {
                if (!Exp[0]) return NULL;
                Res=new char[strlen(Exp)+1];
                strcpy(Res,Exp);
                for (i=0;Exp[i];i++) Exp[i]='\0';
                return Res;
        }
}

char *GetIntervalles(char *Exp)
{
/*        char *Tmp=strchr(Exp,'.');
        int i=Tmp-Exp;
        int j;
        
        while ((Exp[i-1]!=',') && (i>=0)) i--;
        printf("\n Valeur de i: %d",i);
        getchar();
        if (i)
        {
                char *Res=new char[strlen(Exp)-i];
                for(j=0;Exp[j];j++) Res[j]=Exp[i+j]; Res[j]='\0';
                Exp[i-1]='\0';
                return Res;
        } */return NULL;
}

int TestFonction(char *Exp,char **Nom)
{
/*        char *Tmp,*Tmp1;
        int n,i;
        Tmp=strchr(Exp,'(');
        if (!Tmp) return 0;
        n=(int)(Tmp-Exp);
        if (!(Tmp1=Copie(1,n,Exp))) return 0;
        if ((EstStandard(Tmp1)) || (EstDans09(Tmp1[0])))
        {
                delete Tmp1;
                return 0;
        }
        for(i=0;Tmp1[i];i++)  if (!((EstDans09(Tmp1[i])) || (EstDansAZaz(Tmp1[i]))))
        {
                delete Tmp1;
                return 0;
        }
        n++;
        Tmp=Copie(n,strlen(Exp),Exp);
        n=0;
        for(i=0;Tmp[i];i++)
        {
                if (Tmp[i]=='(') n++;
                if (Tmp[i]==')') n--;
                if ((!n) && (EstOperateur(Tmp[i])))
                {
                        delete Tmp1;
                        delete Tmp;
                        return 0;
                }
       	}
       	Nom[0]=Tmp1;
       	delete Tmp;*/
       	return 1;
}


int CompteLig(char *Exp)
{
        int i,n,k=0;
        n=1;
        for (i=0;((Exp[i]!=']') && (Exp[i]));i++)
        {
        	if (Exp[i]=='(') k++; else
        	if (Exp[i]==')') k--; else if ((Exp[i]==',') && (!k)) n++;
        }
        return n;
}


                	
int EstVariable(char *Exp)
{
        if (!EstDansAZaz(Exp[0])) return 0;
        int i, n=strlen(Exp);
        for(i=0;i<n;i++) if ((!EstDansAZaz(Exp[i])) && (!EstDans09(Exp[i]))) return 0;
}



