 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: complexe.h,v 1.3 2001/03/18 22:34:14 daville Exp $
 * $Log: complexe.h,v $
 * Revision 1.3  2001/03/18 22:34:14  daville
 * Ajout de lignes fin fichier.
 *
 * Revision 1.2  2000/11/02 21:46:13  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef COMPLEX
#define COMPLEX
#include "number.h"


class CComplexe
{
        SComplexe *Z;
        public:
        CComplexe();
        CComplexe(CComplexe &z);
        CComplexe(SComplexe &z);
        CComplexe &operator= (CComplexe &z);
        CComplexe operator+ (CComplexe &z);
        CComplexe operator* (CComplexe &z);
        //~CComplexe;
};

#endif

