 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: reponse.h,v 1.3 2001/04/03 23:51:35 daville Exp $
 * $Log: reponse.h,v $
 * Revision 1.3  2001/04/03 23:51:35  daville
 * Ajout de lignes fin de fichier.
 *
 * Revision 1.2  2000/11/02 22:09:51  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef REPONSE_H
#define REPONSE_H
#include "stdio.h"
#include "type.h"

class CReponse
{
       private:
       	char *Msgs[2]; //[0]<==> 'f(x)=sin(.., et [1]<===> 'cannot make ...'
       	int PosErreur;
       
       public:
       	void *ObjX;
       	TReponse IDRep;
       
       public:
       	CReponse(){Msgs[0]=Msgs[1]=NULL;PosErreur=-1;IDRep=TR_VOID;};
       	CReponse(CReponse &reponse);
       	CReponse(TReponse id, char *Msg, char *Erreur, int i=-1);
       	CReponse(TReponse id, void *obj){IDRep=id; ObjX=obj;};
       	char *GetAfficher();
       	int Afficher();
       	~CReponse();
};

#endif
