 /***********************************************************************
 * =======================================				*
 * EasyMaths - Core component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: utils.h,v 1.3 2001/04/03 23:49:31 daville Exp $
 * $Log: utils.h,v $
 * Revision 1.3  2001/04/03 23:49:31  daville
 * Ajout de lignes fin de fichier.
 *
 * Revision 1.2  2000/11/02 22:09:51  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef UTILS_H
#define UTILS_H
#include "type.h"

void Decompress(char *ss, char **sd);

char *GetGroupOf(TOperator op);
char *GetCharOf(TOperator op);
TOperator GetTSOperator(char *exp);
TOperator GetTNSOperator(char *op);
TOperator IsSimpleOperator(char op);
TOperator IsKeyWord(char *exp);

SObjectX* MakeObjectXFromStree(STree *st);
TObjectX ConvertToTObjectX(TOperator op);
TObjectX DelimitToTObjectX(char *op);
char *GetGroupeName(TObjectX type);

#endif  /* UTILS_H */
