 /***********************************************************************
 * =======================================				*
 * EasyMaths - IHM component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: FichierConf.h,v 1.3 2001/04/04 20:16:02 daville Exp $
 * $Log: FichierConf.h,v $
 * Revision 1.3  2001/04/04 20:16:02  daville
 * Ajout de lignes fin de fichier.
 *
 * Revision 1.2  2000/11/02 22:29:12  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef FICHIER_CONF_H
#define FICHIER_CONF_H
#include <string.h>
#include <stdio.h>

FILE *OuvrirFichierConf(char *nom_fichier);
char *LireParametreFichierConf(FILE *fichier, char *nom_section, char *nom_parametre);
int   EcrireParametreFichierConf(FILE *fichier, char *nom_section, char *nom_parametre, char *valeur_parametre);
int   FermerFichierConf(FILE *fichier);

#endif  /* FICHIER_CONF_H */

