 /***********************************************************************
 * =======================================				*
 * EasyMaths - IHM component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: Handlers_Signal.h,v 1.3 2001/04/04 20:18:34 daville Exp $
 * $Log: Handlers_Signal.h,v $
 * Revision 1.3  2001/04/04 20:18:34  daville
 * Ajout de lignes fin de fichier.
 *
 * Revision 1.2  2000/11/02 22:29:12  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


ON_SIGNAL(mMenu000, activate_signal, FINouveau),
ON_SIGNAL(mMenu001, activate_signal, FIOuvrir),
ON_SIGNAL(mMenu002, activate_signal, FIEnregistrer),
ON_SIGNAL(mMenu003, activate_signal, FIEnregistrerSs),
ON_SIGNAL(mMenu004, activate_signal, FIConfigurerImp),
ON_SIGNAL(mMenu005, activate_signal, FIImprimer),
ON_SIGNAL(mMenu006, activate_signal, FIMiseEnPage),
ON_SIGNAL(mMenu007, activate_signal, FIFermerFichier),
ON_SIGNAL(mMenu00700,activate_signal, FIViderLaListe),
ON_SIGNAL(mMenu008, activate_signal, FIFermer),
ON_SIGNAL(mMenu009, activate_signal, FIQuitter),

ON_SIGNAL(mMenu100, activate_signal, EDAnnuler),
ON_SIGNAL(mMenu101, activate_signal, EDCouper),
ON_SIGNAL(mMenu102, activate_signal, EDCopier),
ON_SIGNAL(mMenu103, activate_signal, EDColler),
	
ON_SIGNAL(mMenu200, activate_signal, BIStandard),
ON_SIGNAL(mMenu201, activate_signal, BIEasyMaths),
ON_SIGNAL(mMenu202, activate_signal, BIUtilisateur),

ON_SIGNAL(mMenu300, activate_signal, VUView2D),
ON_SIGNAL(mMenu301, activate_signal, VUView3D),

ON_SIGNAL(mMenu400, activate_signal, OPFenetre),
ON_SIGNAL(mMenu401, activate_signal, OPGraphe),
ON_SIGNAL(mMenu402, activate_signal, OPPile),

ON_SIGNAL(mMenu500, activate_signal, OUDocument),
ON_SIGNAL(mMenu501, activate_signal, OUDocument),
ON_SIGNAL(mMenu502, activate_signal, OUDocument),
ON_SIGNAL(mMenu503, activate_signal, OUDocument),
ON_SIGNAL(mMenu504, activate_signal, OUDocument),

ON_SIGNAL(mMenu600, activate_signal, AIAide),
ON_SIGNAL(mMenu601, activate_signal, AIAideCont),
ON_SIGNAL(mMenu602, activate_signal, AIAideAPP),

ON_SIGNAL(mToolbar0, clicked_signal, HandleToolbarSys),
ON_SIGNAL(mToolbar1, clicked_signal, HandleToolbarMat),

ON_SIGNAL(mTextin, realize_signal, HandleTextIn),
ON_SIGNAL(mTextout, text_changed_signal, HandleTextOut)

