 /***********************************************************************
 * =======================================				*
 * EasyMaths - IHM component of EasyMaths				*
 * November 2000							*
 * =======================================				*
 *									*
 * Copyright (C) 2000, 2001 Didier Davill				*
 * Developed by Didier Davill <Didier.Daville@ddarea.com>		*
 *									*
 * This library is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU Library General Public License as 	*
 * published by the Free Software Foundation; either version 2 of the	*
 * License, or (at your option) any later version.			*
 *									*
 * This library is distributed in the hope that it will be useful, but	*
 * WITHOUT ANY WARRANTY; without even the implied warranty of		*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.			*
 * See the GNU Library General Public License for more details.		*
 *									*
 * You should have received a copy of the GNU Library General Public	*
 * License along with this library; if not, write to the Free Software	*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA		*
 * 02111-1307, USA.							*
 ***********************************************************************/

 /***********************************************************************
 * $Author: daville $
 *
 * $Revision: 1.3 $
 *
 * $Id: Pixmaps.h,v 1.3 2001/04/04 20:19:59 daville Exp $
 * $Log: Pixmaps.h,v $
 * Revision 1.3  2001/04/04 20:19:59  daville
 * Ajout de lignes fin de fichier.
 *
 * Revision 1.2  2000/11/02 22:30:20  daville
 * Intgration de l'entte de copyright et de suivi de version.
 *
 *
 ***********************************************************************/


#ifndef XMATHPIXMAP_H
#define XMATHPIXMAP_H

#include <Pixmaps/new.xpm>
#include <Pixmaps/open.xpm>
//#include <Pixmaps/exit.xpm>
#include <Pixmaps/graphs.xpm>
#include <Pixmaps/jgraph.xpm>
#include <Pixmaps/jlower.xpm>
#include <Pixmaps/mini-cross.xpm>
#include <Pixmaps/mini-book1.xpm>
#include <Pixmaps/mini-manual.xpm>
#include <Pixmaps/mini-ofolder.xpm>
#include <Pixmaps/mini-pdf.xpm>
#include <Pixmaps/mini-roach.xpm>
#include <Pixmaps/mini-run.xpm>
#include <Pixmaps/mini-stop.xpm>
#include <Pixmaps/mini-turn.xpm>
#include <Pixmaps/mini-windows.xpm>
#include <Pixmaps/mini.cut.xpm>
#include <Pixmaps/mini.xterm.xpm>
//#include <Pixmaps/world.xpm>

//********************************
#include <Pixmaps/xmath.xpm>
#include <Pixmaps/logoeasymaths.xpm>
#include <Pixmaps/diff.xpm>
#include <Pixmaps/function.xpm>
#include <Pixmaps/graph2d.xpm>
#include <Pixmaps/graph3d.xpm>
#include <Pixmaps/int.xpm>
#include <Pixmaps/sum.xpm>
#include <Pixmaps/matrix.xpm>
#include <Pixmaps/variable.xpm>
//********************************


#define XMATH_LOGOXPM		xmath_xpm
#define EASYMATHS_LOGOXPM	logoeasymaths_xpm
#define HELPXPM			mini_book1_xpm
#define MANUALXPM		mini_manual_xpm
#define MINIMANUALXPM		mini_xman_xpm
#define NEWXPM			new_xpm
#define OPENXPM			open_xpm
#define OUVRIRXPM		mini_ofolder
#define SAVEXPM			mini_run_xpm
#define RUNXPM			mini_run_xpm
#define CANCELXPM		mini_turn_xpm
#define COPYXPM			mini_windows_xpm
#define CUTXPM			image_name
#define PASTXPM			jlower_xpm
#define STOPXPM			mini_stop_xpm
#define GRAPHXPM		jgraph_xpm
#define GRAPHSXPM		icl8_15303_xpm
#define CONFIGSYSXPM		mini_xterm_xpm
#define CANCELPROGXPM		mini_roach_xpm
#define TRACERCOURBEXPM		mini_pdf_xpm
#define WORLDXPM		mini_cross_xpm
#define KILLXPM			mini_cross_xpm
#define FERMERXPM		mini_cross_xpm



/* Bar d'outils pour les objets mathmatiques  */

#define VARIABLEXPM		variable_xpm
#define INTERVALXPM		mini_manual_xpm
#define POLYNOMEXPM	      	mini_xman_xpm
#define FUNCTIONXPM		function_xpm
#define SUMXPM			sum_xpm
#define MATRIXXPM		matrix_xpm
#define INTEGRALXPM		int_xpm
#define DERIVATEXPM		diff_xpm
#define GRAPH2DXPM		graph2d_xpm
#define GRAPH3DXPM		graph2d_xpm

#endif  /* XMATHPIXMAP_H */

